'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var AsyncButton = function (_React$Component) {
  _inherits(AsyncButton, _React$Component);

  function AsyncButton(props) {
    _classCallCheck(this, AsyncButton);

    var _this = _possibleConstructorReturn(this, (AsyncButton.__proto__ || Object.getPrototypeOf(AsyncButton)).call(this, props));

    _this.state = {
      asyncState: null
    };
    return _this;
  }

  _createClass(AsyncButton, [{
    key: 'resetState',
    value: function resetState() {
      this.setState({
        asyncState: null
      });
    }
  }, {
    key: 'handleClick',
    value: function handleClick() {
      var _this2 = this;

      var clickHandler = this.props.onClick;
      if (typeof clickHandler === 'function') {
        this.setState({
          asyncState: 'pending'
        });

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
          args[_key] = arguments[_key];
        }

        var returnFn = clickHandler(args);
        if (returnFn && typeof returnFn.then === 'function') {
          returnFn.then(function () {
            _this2.setState({
              asyncState: 'fulfilled'
            });
          }).catch(function (error) {
            _this2.setState({
              asyncState: 'rejected'
            });
            throw error;
          });
        } else {
          this.resetState();
        }
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _classNames,
          _this3 = this;

      var _props = this.props;
      var children = _props.children;
      var text = _props.text;
      var pendingText = _props.pendingText;
      var fulFilledText = _props.fulFilledText;
      var rejectedText = _props.rejectedText;
      var className = _props.className;
      var loadingClass = _props.loadingClass;
      var fulFilledClass = _props.fulFilledClass;
      var rejectedClass = _props.rejectedClass;
      var disabled = _props.disabled;

      var attributes = _objectWithoutProperties(_props, ['children', 'text', 'pendingText', 'fulFilledText', 'rejectedText', 'className', 'loadingClass', 'fulFilledClass', 'rejectedClass', 'disabled']);

      var asyncState = this.state.asyncState;

      var isPending = asyncState === 'pending';
      var isFulfilled = asyncState === 'fulfilled';
      var isRejected = asyncState === 'rejected';
      var isDisabled = disabled || isPending;
      var btnClasses = (0, _classnames2.default)(className, (_classNames = {}, _defineProperty(_classNames, loadingClass, isPending), _defineProperty(_classNames, fulFilledClass, isFulfilled), _defineProperty(_classNames, rejectedClass, isRejected), _classNames));
      var buttonText = void 0;

      if (isPending) {
        buttonText = pendingText;
      } else if (isFulfilled) {
        buttonText = fulFilledText;
      } else if (isRejected) {
        buttonText = rejectedText;
      }
      buttonText = buttonText || text;

      return _react2.default.createElement(
        'button',
        _extends({}, attributes, {
          className: btnClasses,
          disabled: isDisabled,
          onClick: function onClick() {
            return _this3.handleClick();
          }
        }),
        typeof children === 'function' ? children({
          buttonText: buttonText,
          isPending: isPending,
          isFulfilled: isFulfilled,
          isRejected: isRejected
        }) : children ? children : buttonText
      );
    }
  }]);

  return AsyncButton;
}(_react2.default.Component);

exports.default = AsyncButton;


AsyncButton.propTypes = {
  children: _react.PropTypes.oneOfType([_react.PropTypes.func, _react.PropTypes.element]),
  className: _react.PropTypes.string,
  loadingClass: _react.PropTypes.string,
  fulFilledClass: _react.PropTypes.string,
  rejectedClass: _react.PropTypes.string,
  disabled: _react.PropTypes.bool,
  text: _react.PropTypes.string,
  pendingText: _react.PropTypes.string,
  fulFilledText: _react.PropTypes.string,
  rejectedText: _react.PropTypes.string,
  onClick: _react.PropTypes.func
};

AsyncButton.defaultProps = {
  loadingClass: 'AsyncButton--loading',
  fulFilledClass: 'AsyncButton--fulfilled',
  rejectedClass: 'AsyncButton--rejected'
};